addonName, ns = ...

local module = {}
module.name = "ActionBars"
module.Init = function()
	if not SCDB.modules[module.name] then return end
	if SCDB[module.name] == nil then SCDB[module.name] = {} end
    if SCDB[module.name]["Hide hotkeys"] == nil then SCDB[module.name]["Hide hotkeys"] = false end
	
	local r2, g2, b2, a2 = cl and SuperClassic.cc.r or .4, cl and SuperClassic.cc.g or .4, cl and SuperClassic.cc.b or .4, 1 -- bottom color
	
	local overlays = { "MASTER_MARKSMAN.BLP", "FOCUS_FIRE.BLP", "LOCK_AND_LOAD.BLP", "BLOOD_SURGE.BLP", "SWORD_AND_BOARD.BLP", "SUDDEN_DEATH.BLP", "MAELSTROM_WEAPON.BLP", "FULMINATION.BLP", "IMPACT.BLP", "FROZEN_FINGERS.BLP", "ARCANE_MISSILES.BLP", "HOT_STREAK.BLP", "BRAIN_FREEZE.BLP", "SURGE_OF_LIGHT.BLP", "MOLTEN_CORE.BLP", "BACKLASH.BLP", "IMP_EMPOWERMENT.BLP", "NIGHTFALL.BLP", "NATURES_GRACE.BLP", "GENERICTOP_01.BLP", "ECLIPSE_SUN.BLP", "FURY_OF_STORMRAGE.BLP", "ECLIPSE_MOON.BLP", "SHOOTING_STARS.BLP", "DARK_TRANSFORMATION.BLP", "SUDDEN_DOOM.BLP", "RIME.BLP", "KILLING_MACHINE.BLP", "GRAND_CRUSADER.BLP", "ART_OF_WAR.BLP", "DAYBREAK.BLP", "HAND_OF_LIGHT.BLP", }
	
	local PSF = CreateFrame("FRAME")
	PSF:RegisterEvent("UNIT_AURA")
	PSF:SetScript("OnEvent", function() 
		local o = 0 
		for i = 1, 40 do 
			local id = select(11, UnitAura("player", i))
			if id == 69369 then 
				SpellActivationOverlay_ShowOverlay(SpellActivationOverlayFrame, 69369, "TEXTURES\\SPELLACTIVATIONOVERLAYS\\"..overlays[22], "TOP", 2.3, 255, 255, 255, false, false)
				o = 1
			end
		end
		if o == 0 then
			SpellActivationOverlay_HideOverlays(SpellActivationOverlayFrame, 69369)
		end
	end)
	
	
	MainMenuBarTexture0:Hide() MainMenuBarTexture1:Hide() MainMenuBarTexture2:Hide() MainMenuBarTexture3:Hide()
	MainMenuBarLeftEndCap:Hide() MainMenuBarRightEndCap:Hide()
	MainMenuMaxLevelBar0:Hide() MainMenuMaxLevelBar1:Hide() MainMenuMaxLevelBar2:Hide() MainMenuMaxLevelBar3:Hide()
	BonusActionBarFrameTexture1:SetAlpha(0) BonusActionBarFrameTexture2:SetAlpha(0)	BonusActionBarFrameTexture3:SetAlpha(0)	BonusActionBarFrameTexture4:SetAlpha(0)
	MainMenuBar:SetScale(.85) MultiBarRight:SetScale(.85) MultiBarRight:ClearAllPoints() MultiBarRight:SetPoint("RIGHT", UIParent,"RIGHT")
	MultiBarBottomLeft:ClearAllPoints()
	MultiBarBottomLeft:SetPoint("BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 6)
	MultiBarBottomLeft.SetPoint = function() end
	ActionBarUpButton:Hide()
	ActionBarDownButton:Hide()

	local styleb = function(self)
	  if not self.styled then
			local bname = self:GetName()
			local button, icon, border, fbg = _G[bname], _G[bname.."Icon"], _G[bname.."Border"], _G[bname.."FloatingBG"]
			
			if fbg then fbg:Hide() fbg.Show = function() end end
			if border then border:Hide() border.Show = function() end end

            local nt = button:GetNormalTexture()
            if nt then
				nt:SetVertexColor(r2, g2, b2, a2)
				
				if not button.hooked then
					hooksecurefunc(nt, "SetVertexColor", function(snt, r, g, b, a)
						if snt then
							local self = snt:GetParent()
							local action = self.action
							if r==1 and g==1 and b==1 and action and (IsEquippedAction(action)) then
								snt:SetVertexColor(0,1,0,1)
							elseif r==0.5 and g==0.5 and b==1 then
								snt:SetVertexColor(0,0,1,1)
							elseif r==1 and g==1 and b==1 then
								snt:SetVertexColor(r2, g2, b2, a2)
							end
						end
					end)
					button.hooked = true
				end
            end
			
			if icon then 
				icon:SetTexCoord(.1, .9, .1, .9) 
				if button:GetPushedTexture() then button:GetPushedTexture():SetAllPoints(icon) end
				if button.GetCheckedTexture then button:GetCheckedTexture():SetAllPoints(icon) end
				if button.GetHighlightTexture then button:GetHighlightTexture():SetAllPoints(icon) end
			end
			
			self.styled = true
	  end
	end

	local shapeshiftBarUpdate = function()    
		for i=1, NUM_SHAPESHIFT_SLOTS do
			styleb(_G["ShapeshiftButton"..i])
		end    
	end

	hooksecurefunc("ShapeshiftBar_OnLoad", shapeshiftBarUpdate)
	hooksecurefunc("ShapeshiftBar_UpdateState", shapeshiftBarUpdate)
	hooksecurefunc("ActionButton_Update", styleb)
	hooksecurefunc("PetActionBar_Update", function()
		for i=1, NUM_PET_ACTION_SLOTS do
			styleb(_G["PetActionButton"..i])
		end  
	end)

	hooksecurefunc("ActionButton_UpdateHotkeys", function(self, btype)
		if (not btype) then btype = "ACTIONBUTTON" end
		local hotkey, macro = _G[self:GetName().."HotKey"], _G[self:GetName().."Name"]
			
		local key = GetBindingKey(btype..self:GetID()) or GetBindingKey("CLICK "..self:GetName()..":LeftButton")
		local text = GetBindingText(key, "KEY_", 1)
		hotkey:SetText(text)

		if hotkey then hotkey:SetPoint("TOPRIGHT", -2, -2) hotkey:SetFont(hotkey:GetFont(), 12, "OUTLINE") end
		if macro then macro:SetFont(hotkey:GetFont(), 10, "OUTLINE") end
		
		if SCDB[module.name]["Hide hotkeys"] then
			hotkey:Hide()
			macro:Hide()
		end
	end)
	
	for i,v in pairs({_G['CharacterBag3Slot'], _G['CharacterBag2Slot'], _G['CharacterBag1Slot'], _G['CharacterBag0Slot'], _G['MainMenuBarBackpackButton']}) do styleb(v) end
	
end
tinsert(SuperClassic.modules, module) -- finish him!