local module = {}
module.name = "Nameplates"
module.Init = function()
	if not SCDB.modules[module.name] then return end
	if SCDB[module.name] == nil then SCDB[module.name] = {} end
	local opts = SCDB[module.name]

	local nameplates = CreateFrame("Frame", nil, UIParent)
	local mult = 768/string.match(GetCVar("gxResolution"), "%d+x(%d+)")
	
	SetCVar("ShowClassColorInNameplate", 1)
	SetCVar("bloatthreat", 0)
	SetCVar("bloattest", 0)
	SetCVar("bloatnameplates", 0)

	rgb2str = function(col) local r, g, b = unpack(col) return format("|cff%02x%02x%02x", r*255, g*255, b*255) end
	rgb2str = function(r, g, b) return format("|cff%02x%02x%02x", r*255, g*255, b*255) end
	
	local MakeAuraWidget = function(self)
		if not self.auraplate then
			local DebuffColor = {
				Magic	= { .2, .6, 1 },
				Curse	= { .6, 0, 1 },
				Disease = { .6, .4, 0 },
				Poison = { 0, .6, 0 },
			}
		
			local healthBar, castBar = self:GetChildren()
			self.auraplate = CreateFrame("frame", self:GetName().."auraplate", self)
			self.auraplate:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			local unitName = select(4, self:GetRegions()):GetText() or ""

			local getAura = function(self, spellId)
				for i,v in pairs(self.auraplate.auras) do
					if v:GetScript("OnUpdate") == nil or v.spellId == spellId then
						return v
					end
				end
			end
			
			local freeAll = function(self)
				for i,v in pairs(self.auraplate.auras) do
					v:SetScript("OnUpdate", nil)
				end
			end
			
			self.auraplate:SetScript("OnEvent", function(self, event, ...)
				local _, eventType, _, _, srcName, srcFlags, _, _, _, _, _, spellID, spellName = ...
				if (eventType == "SPELL_CAST_SUCCESS" or eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" or eventType == "SPELL_AURA_REMOVED") and srcName == UnitName("player") then
				
					local unit
					if unitName then
						local uname = UnitName("target")
						if uname == unitName then unit = "target" end
						if not unit then
							uname = UnitName("mouseover")
							if uname == unitName then unit = "mouseover" end
						end
						
						if unit then
							--freeAll(self:GetParent())
							for i=1,40 do
								local name, _, icon, count, debuffType, duration, expirationTime, unitCaster, _, _, spellId = UnitAura(unit, i, "HARMFUL")
								if name and unitCaster == "player" then
									local aura = getAura(self:GetParent(), spellID)
									if aura and aura.duration ~= duration then
										aura.spellId = spellID
										aura.icon:SetTexture(icon)
										aura.start = GetTime()
										aura.duration = duration
										aura.cd:SetCooldown(GetTime(), duration)
										if debuffType then
											aura.border:SetTexture(unpack(DebuffColor[debuffType]))
										end
										aura:Show()

										aura:SetScript("OnUpdate", function(self, elapsed)
											if not self.t then self.t = 0 end
											self.t = self.t + elapsed
											if self.t > .1 then return end
											
											self.cooldown = self.start + self.duration - GetTime()
											if self.cooldown <= 0 then
												self:Hide()
												self:SetScript("OnUpdate", nil)
												self.border:SetTexture(nil)
												self.icon:SetTexture(nil)
												self.spellId = nil
											end
											self.t = 0
										end)
									else
										return
									end
								end
							end
						end
					end
				
				
					
				end
			end)
			
			self.auraplate:SetPoint("BOTTOMLEFT", healthBar, "TOPLEFT", 0, 0)
			self.auraplate:SetSize(healthBar:GetWidth(), 100)
			self.auraplate.auras = {}
			local gap = mult
			local count = 0
			for i=1,2 do
				for j=0,3 do
					local aura = CreateFrame("frame", self:GetName().."AurasAura"..count, self.auraplate)
					local aurasize = self.auraplate:GetWidth()/4
					aura:SetSize(aurasize, aurasize)
					aura:SetPoint("BOTTOMLEFT", j*(aurasize+gap), i*(aurasize+gap))
					aura.icon = aura:CreateTexture(nil, "BORDER")
					aura.icon:SetDrawLayer("BORDER", -1)
					aura.icon:SetTexture(1,1,1)
					aura.icon:SetTexCoord(.1,.9,.1,.9)
					aura.icon:SetPoint("TOPLEFT", mult*2, -mult*2)
					aura.icon:SetPoint("BOTTOMRIGHT", -mult*2, mult*2)
					aura.border = aura:CreateTexture(nil, "BORDER")
					aura.border:SetDrawLayer("BORDER", -2)
					aura.border:SetAllPoints()
					aura.cd = CreateFrame("Cooldown", nil, aura)
					aura.cd:SetPoint("TOPLEFT", mult*2, -mult*2)
					aura.cd:SetPoint("BOTTOMRIGHT", -mult*2, mult*2)
					
					aura:EnableMouse(false)
					aura:Hide()
					tinsert(self.auraplate.auras, aura)
					count = count + 1
				end
			end
		end
	end
	
	--Create a fake backdrop frame using textures (Tukz)
	local function CreateVirtualFrame(parent, point)
		if point == nil then point = parent end
		if point.backdrop then return end
		parent.backdrop = parent:CreateTexture(nil, "BORDER")
		parent.backdrop:SetDrawLayer("BORDER", -8)
		parent.backdrop:SetPoint("TOPLEFT", point, "TOPLEFT", -mult, mult)
		parent.backdrop:SetPoint("BOTTOMRIGHT", point, "BOTTOMRIGHT", mult, -mult)
		parent.backdrop:SetTexture(.1,.1,.1)
		
		parent.bordertop = parent:CreateTexture(nil, "BORDER")
		parent.bordertop:SetPoint("TOPLEFT", point, "TOPLEFT", -mult, mult*2)
		parent.bordertop:SetPoint("TOPRIGHT", point, "TOPRIGHT", mult, mult*2)
		parent.bordertop:SetHeight(mult)
		parent.bordertop:SetTexture(.6,.6,.6)	
		parent.bordertop:SetDrawLayer("BORDER", -7)
		
		parent.borderbottom = parent:CreateTexture(nil, "BORDER")
		parent.borderbottom:SetPoint("BOTTOMLEFT", point, "BOTTOMLEFT", -mult, -mult*2)
		parent.borderbottom:SetPoint("BOTTOMRIGHT", point, "BOTTOMRIGHT", mult, -mult*2)
		parent.borderbottom:SetHeight(mult)
		parent.borderbottom:SetTexture(.6,.6,.6)	
		parent.borderbottom:SetDrawLayer("BORDER", -7)
		
		parent.borderleft = parent:CreateTexture(nil, "BORDER")
		parent.borderleft:SetPoint("TOPLEFT", point, "TOPLEFT", -mult*2, mult)
		parent.borderleft:SetPoint("BOTTOMLEFT", point, "BOTTOMLEFT", mult*2, -mult)
		parent.borderleft:SetWidth(mult)
		parent.borderleft:SetTexture(.6,.6,.6)	
		parent.borderleft:SetDrawLayer("BORDER", -7)
		
		parent.borderright = parent:CreateTexture(nil, "BORDER")
		parent.borderright:SetPoint("TOPRIGHT", point, "TOPRIGHT", mult*2, mult)
		parent.borderright:SetPoint("BOTTOMRIGHT", point, "BOTTOMRIGHT", -mult*2, -mult)
		parent.borderright:SetWidth(mult)
		parent.borderright:SetTexture(.6,.6,.6)	
		parent.borderright:SetDrawLayer("BORDER", -7)	
		
	end

	local function SetVirtualBorder(parent, r, g, b, a) 
		parent.bordertop:SetTexture(r, g, b)
		parent.borderbottom:SetTexture(r, g, b)
		parent.borderleft:SetTexture(r, g, b)
		parent.borderright:SetTexture(r, g, b)
	end	
	
	local styleNamePlate = function(self)
		local healthBar, castBar = self:GetChildren()
		if not healthBar and not castBar then return end
		if self.styled == true then return end

		local barfill, castborderTexture, shield, castbaricon = castBar:GetRegions()
		local threatTexture, borderTexture, highlightTexture, nameText, levelText, bossIcon, raidIcon, dragonTexture = self:GetRegions() 
		highlightTexture:SetDrawLayer("BACKGROUND")
		
		healthBar:SetFrameLevel(1)
		healthBar:SetHeight(7)
		CreateVirtualFrame(healthBar)
				
		healthBar.hpbg = healthBar:CreateTexture(nil, 'BORDER')
		healthBar.hpbg:SetAllPoints(healthBar)
		healthBar.hpbg:SetTexture(.1, .1, .1, .25) 		
		
		local r,g,b = healthBar:GetStatusBarColor()
		r,g,b = floor(r*100+.5)/100, floor(g*100+.5)/100, floor(b*100+.5)/100
		
		self.name = nameText
		self.name:SetFont(STANDARD_TEXT_FONT, 10, "OUTLINE")
		self.name:SetShadowOffset(0,0)
		
		if (r == 0 and g == 0 and b == 1) then
			self.name:SetTextColor(0,.7,1)
		elseif (r==0 and g==1 and b==0) then
			self.name:SetTextColor(0,1,.7)
		elseif (r==1 and g==1 and b==0) then
			self.name:SetTextColor(.7,1,0)
		else
			self.name:SetTextColor(r,g,b)
		end
		
		castBar:SetStatusBarTexture("Interface\\Addons\\"..addonName.."\\media\\texture\\statusbar")
		highlightTexture:SetTexture(1,1,1,.3)
		highlightTexture:ClearAllPoints()
		highlightTexture:SetAllPoints(healthBar)

		healthBar:SetStatusBarTexture("Interface\\Addons\\"..addonName.."\\media\\texture\\statusbar", "BORDER")
		
		self.name:SetJustifyH("CENTER")
		self.name:SetPoint("BOTTOM", healthBar, "TOP", 0, mult*5)

		self.level = levelText
		self.level:SetFont(STANDARD_TEXT_FONT, 10, "OUTLINE")
		local r,g,b = levelText:GetTextColor()
		self.level:SetText(rgb2str(r,g,b)..(levelText:GetText() or "").."|r")
		self.level:ClearAllPoints()
		self.level:SetPoint("RIGHT", healthBar, "LEFT", -mult*5, 0)
		self.level:SetShadowOffset(0,0)
		
		--boss icon
		bossIcon:ClearAllPoints()
		bossIcon:SetPoint("RIGHT", self.name, "LEFT", 0, 0)

		--castbars
		local w,h = healthBar:GetSize()
		castBar:SetSize(w,h-2)
		castBar:ClearAllPoints()
		castBar:SetPoint("BOTTOM", healthBar, 0, -mult*11)
		CreateVirtualFrame(castBar)

		castbaricon:ClearAllPoints()
		castbaricon:SetPoint("TOPLEFT", healthBar, "TOPRIGHT", mult*8, 0)		
		castbaricon:SetSize(20, 20)
		castbaricon:SetTexCoord(.07, .93, .07, .93)
		castbaricon:SetDrawLayer("OVERLAY")
		CreateVirtualFrame(castBar, castbaricon)
		self.icon = castbaricon
		
		castBar.shield = shield
		shield:ClearAllPoints()
		shield:SetPoint("TOP", castBar, "BOTTOM")
		
		castBar.icon = castbaricon
		
		local UpdateCastBar = function(self)
			local w,h = healthBar:GetSize()
			self:SetSize(w,h-2)
			self:ClearAllPoints()
			self:SetPoint("TOP", healthBar, "BOTTOM", 0, -mult*11)

			self.icon:ClearAllPoints()
			self.icon:SetPoint("TOPLEFT", healthBar, "TOPRIGHT", mult*8, 0)		
			self.icon:SetSize(20, 20)
			self.icon:SetTexCoord(.07, .93, .07, .93)
			self.icon:SetDrawLayer("OVERLAY")

			if(self.shield:IsShown()) then
				self:SetStatusBarColor(0.78, 0.25, 0.25, 1)
			end
		end
		
		--Create Cast Time Text
		castBar.time = castBar:CreateFontString(nil, "ARTWORK")
		castBar.time:SetPoint("RIGHT", castBar, "LEFT", -1, 0)
		castBar.time:SetFont(STANDARD_TEXT_FONT, 10, "OUTLINE")
		castBar.time:SetShadowColor(0, 0, 0, 0.4)
		castBar.time:SetTextColor(1, 1, 1)
		castBar.time:SetShadowOffset(mult, -mult)
		
		
		--Determine whether or not the cast is Channelled or a Regular cast so we can grab the proper Cast Name
		local function UpdateCastText(frame, curValue)
			local minValue, maxValue = frame:GetMinMaxValues()
			if UnitChannelInfo("target") then frame.time:SetFormattedText("%.1f ", curValue) end
			if UnitCastingInfo("target") then frame.time:SetFormattedText("%.1f ", maxValue - curValue) end
		end

		--Sometimes castbar likes to randomly resize
		local OnValueChanged = function(self, curValue)
			UpdateCastText(self, curValue)
			if self.needFix then
				UpdateCastBar(self)
				self.needFix = nil
			end
		end

		--Sometimes castbar likes to randomly resize
		local OnSizeChanged = function(self)
			self.needFix = true
		end

		--We need to reset everything when a nameplate it hidden, this is so theres no left over data when a nameplate gets reshown for a differant mob.
		local function OnHide(frame)
			frame.hp:SetStatusBarColor(frame.hp.rcolor, frame.hp.gcolor, frame.hp.bcolor)
			frame.overlay:Hide()
			frame.cb:Hide()
			frame.hasClass = nil
			frame.isFriendly = nil
			frame.hp.rcolor = nil
			frame.hp.gcolor = nil
			frame.hp.bcolor = nil

			frame:SetScript("OnUpdate",nil)
		end
		
		castBar:HookScript('OnShow', UpdateCastBar)
		castBar:HookScript('OnSizeChanged', OnSizeChanged)
		castBar:HookScript('OnValueChanged', OnValueChanged)
		
		--raidicon
		raidIcon:ClearAllPoints()
		raidIcon:SetSize(20,20)
		raidIcon:SetPoint("BOTTOM",healthBar,"TOP",0,mult*17)

		--disable some stuff
		dragonTexture:SetTexture(nil) --just plain ugly!
		borderTexture:SetTexture(nil)
		shield:SetTexture(nil)
		castborderTexture:SetTexture(nil)
		threatTexture:SetTexture(nil)
		
		self:HookScript("OnUpdate", function(s, elapsed)
			if not s.sa then s.sa = 0 end
			s.sa = s.sa + elapsed
			
			if s.sa > .1 then
				local healthBar, castBar = s:GetChildren()
				local castborderTexture, barfill, shield, castbaricon = castBar:GetRegions()
				local threatTexture, borderTexture, highlightTexture, nameText, levelText, bossIcon, raidIcon, dragonTexture = s:GetRegions() 
				
				local r,g,b = healthBar:GetStatusBarColor()
				if ceil(r)==0 and ceil(g)==0 and ceil(b)==1 then
					local cls = select(2, UnitClass(nameText:GetText()))
					if cls then
						healthBar:SetStatusBarColor(RAID_CLASS_COLORS[cls].r, RAID_CLASS_COLORS[cls].g, RAID_CLASS_COLORS[cls].b)
					end
				end
				
				healthBar:SetHeight(7)

				if threatTexture:IsVisible() then
					SetVirtualBorder(healthBar, 1, 0, 0)
				else
					SetVirtualBorder(healthBar, .6, .6, .6)
				end
				
				s.name:ClearAllPoints()
				if s.name:GetStringWidth() > healthBar:GetWidth() then
					s.name:SetSize(unpack({healthBar:GetSize()}))
				end
				
				s.name:SetPoint("BOTTOM", healthBar, "TOP", 0, mult*5)
				s.level:ClearAllPoints()
				s.level:SetPoint("RIGHT", healthBar, "LEFT", -mult*5, 0)
				
				s.sa = 0
				
				--MakeAuraWidget(s)
			end
		end)

		
		self:HookScript("OnShow", function(self) 
			local healthBar, castBar = self:GetChildren()
			local castborderTexture, barfill, shield, castbaricon = castBar:GetRegions()
			local threatTexture, borderTexture, highlightTexture, nameText, levelText, bossIcon, raidIcon, dragonTexture = self:GetRegions() 
			
			healthBar:SetHeight(10)
			local r,g,b = healthBar:GetStatusBarColor()
			r,g,b = floor(r*100+.5)/100, floor(g*100+.5)/100, floor(b*100+.5)/100

			if (r == 0 and g == 0 and b == 1) then
				self.name:SetTextColor(0,.7,1)
			elseif (r==0 and g==1 and b==0) then
				self.name:SetTextColor(0,1,.7)
			elseif (r==1 and g==1 and b==0) then
				self.name:SetTextColor(.7,1,0)
			else
				self.name:SetTextColor(r,g,b)
			end
			
			highlightTexture:SetTexture(1,1,1,.3)
			highlightTexture:ClearAllPoints()
			highlightTexture:SetAllPoints(healthBar)
			
			healthBar:SetStatusBarTexture("Interface\\Addons\\"..addonName.."\\media\\texture\\statusbar", "BORDER")
		end)

		self.styled = true
	end

	local IsNamePlateFrame = function(self) return (self:GetName() and self:GetName():find("NamePlate")) end
  
	nameplates:SetScript("OnUpdate", function(self, elapsed)
		if not self.lastupdate then self.lastupdate = 0 end
		self.lastupdate = self.lastupdate + elapsed
		if self.lastupdate > 0.1 then
			self.lastupdate = 0
			local num = select("#", WorldFrame:GetChildren())
			for i = 1, num do
				local f = select(i, WorldFrame:GetChildren())
				if not self.styled and IsNamePlateFrame(f) then 
					styleNamePlate(f)
				end
			end
		end
	end)
	
end
tinsert(SuperClassic.modules, module) -- finish him!